Update version number and mention Thorsten in changelog
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/sh
2 # Filename:      grml-bootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Die Jun 05 13:51:21 CEST 2007 [mika]
8 ################################################################################
9 # http://www.debian.org/releases/stable/i386/index.html.en
10
11 set -e # exit on any error
12
13 VERSION='0.10'
14
15 # source core functions {{{
16 . /etc/grml/lsb-functions
17 . /etc/grml/script-functions
18 # }}}
19
20 # make sure we have what we need {{{
21 check4progs debootstrap || exit 1
22 check4root || exit 1
23 # }}}
24
25 # without config file it won't work {{{
26 if [ -r /etc/debootstrap/config ] ; then
27    . /etc/debootstrap/config
28 else
29    eerror "/etc/debootstrap/config could not be read, exiting." ; eend 1
30    exit 1
31 fi
32 # }}}
33
34 # cmdline handling {{{
35 usage() {
36   einfo "$0 - version $VERSION"
37   echo  "   A wrapper around debootstrap for installing plain Debian via grml"
38   echo
39   einfo "Usage: $0 [options]"
40   echo  "   Adjust /etc/debootstrap/config and invoke $0 afterwards or use the cmdline option:"
41   echo
42   einfo "Valid options:"
43   echo  "
44     -h|--help                   Print this usage information and exit.
45     -v|--version                Show summary of options and exit.
46
47     -t|--target <target>        Target partition (/dev/...) or directory.
48     -r|--release <release>      Specify release of new Debian system. Supported relases: sarge, etch, lenny and sid.
49     -m|--mirror <URL>           Specify mirror which should be used for apt-get/aptitude.
50     -i|--iso <mnt>              Specify mountpoint where Debian ISO is mounted to (instead of using mirror)
51     -p|--mntpoint <mnt>         Specify mountpoint that should be used for mounting the target system.
52     --groot <device>            Specify root device for usage in grub (corresponds with \$TARGET).
53     --grub <device>             Where do you want to install grub to? Use grub syntax for specifying.
54     --password <pwd>            Use specified password as password for user root. Use with caution.
55     --boot_append <appendline>  Add specified appendline to kernel whilst booting
56
57 "
58 }
59
60 while [ "$#" -gt "0" ] ; do
61     case $1 in
62         -v|--version)
63             einfo "$0 - version $VERSION"
64             einfo "Send bug reports to Michael Prokop <mika@grml.org>."
65             eend 0
66             exit 0
67             ;;
68         -t|--target)
69             shift
70             TARGET=$1
71             ;;
72         --grub)
73             shift
74             GRUB=$1
75             ;;
76         --groot)
77             shift
78             GROOT=$1
79             ;;
80         --release)
81             shift
82             RELEASE=$1
83             ;;
84         -p|--mntpoint)
85             shift
86             MNTPOINT=$1
87             ;;
88         --password)
89             shift
90             ROOTPASSWORD=$1
91             ;;
92         -m|--mirror)
93             shift
94             MIRROR=$1
95             CHROOTMIRROR=$1
96             ;;
97         -i|--iso)
98             shift
99             [ -n "$MIRROR" ] && unset MIRROR
100             ISO=$1
101             ;;
102         -h|--help)
103             usage ; eend 0
104             eend 0
105             exit 0
106             ;;
107         *)
108             eerror "Syntax error."
109             usage ; eend 1
110             exit 1
111             ;;
112     esac
113     shift
114 done
115 # }}}
116
117 # set/check variables {{{
118
119 # inside the chroot system the locales might not be available, so use minimum:
120 export LANG=C
121 export LC_ALL=C
122
123 if [ -z "$STAGES" ] ; then
124    STAGES='/etc/debootstrap/stages'
125    [ -d "$STAGES" ] || mkdir -p "$STAGES"
126 fi
127
128 if [ -r $STAGES/grml-debootstrap ] ; then
129    if grep -q done $STAGES/grml-debootstrap ; then
130       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
131       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
132    fi
133 fi
134
135 PARTITION=''
136 DIRECTORY=''
137
138 case $TARGET in
139   /dev/*)
140     PARTITION=1
141     ;;
142   *)
143     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
144     DIRECTORY=1
145     MNTPOINT="$TARGET"
146     MKFS=''
147     TUNE2FS=''
148     FSCK=''
149     GRUB=''
150     GROOT=''
151     ;;
152 esac
153
154 if [ -n "$ARCH" ] ; then
155    ARCHCMD="--arch $ARCH"
156    ARCHINFO=" (${ARCH})"
157 else
158    ARCH="$(dpkg --print-architecture)"
159    ARCHCMD="--arch $ARCH"
160    ARCHINFO=" (${ARCH})"
161 fi
162
163 # make sure we have the right syntax when using an iso image
164 case $ISO in
165    file*) # do nothing
166     ;;
167    *)
168     ISO=file:$1
169     ;;
170 esac
171 ISODIR=${ISO##file:}
172
173 # provide variables to chroot system
174 touch /etc/debootstrap/variables
175 chmod 600 /etc/debootstrap/variables # make sure nobody except root can read it
176 [ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  /etc/debootstrap/variables
177 [ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> /etc/debootstrap/variables
178 [ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> /etc/debootstrap/variables
179 [ -n "$TARGET" ] && echo "TARGET=$TARGET" >> /etc/debootstrap/variables
180 [ -n "$ISO" ]    && echo "ISO=$ISO"       >> /etc/debootstrap/variables
181 [ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
182 [ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> /etc/debootstrap/variables
183 [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> /etc/debootstrap/variables
184
185 # make sure at least $TARGET is set [the partition for the new system]
186 if [ -z "$TARGET" ] ; then
187    eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
188    exit 1
189 fi
190 # }}}
191
192 # helper functions {{{
193 # we want to exit smoothly and clean:
194 bailout(){
195   # make sure $TARGET is not mounted when exiting grml-debootstrap
196   if [ -n "$MNTPOINT" ] ; then
197      if grep -q $MNTPOINT /proc/mounts ; then
198         # make sure nothing is left inside chroot so we can unmount it
199         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
200         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
201         # ugly, but make sure we really don't leav anything
202         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
203         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
204         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
205         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
206         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
207         einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
208      fi
209   fi
210   [ -n "$1" ] && EXIT="$1" || EXIT="1"
211   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
212   exit "$EXIT"
213 }
214 trap bailout 1 2 3 15
215
216 # we want to execute all the functions only once, simple check for it:
217 stage() {
218   if [ -n "$2" ] ; then
219      echo "$2" > "$STAGES/$1"
220      return 0
221   elif grep -q done "$STAGES/$1" 2>/dev/null ; then
222      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
223      return 1
224   fi
225 }
226 # }}}
227
228 # user should recheck his configuration {{{
229 # support full automatic installation:
230 checkforrun() {
231    dialog --timeout 10 --title "$0" \
232           --yesno "Do you want to stop at this stage?
233
234 Notice: you are running grml-debootstrap in non-interactive mode.
235 grml-debootstrap will install Debian ${RELEASE} on ${TARGET}.
236 Last chance to quit. Timeout of 10 seconds running....
237
238 Do you want to stop now?" 0 0 2>/dev/null
239 }
240
241 if [ -n "$AUTOINSTALL" ] ; then
242    if checkforrun ; then
243       eerror "Exiting as requested" ; eend 0
244       exit 1
245    fi
246 else # if not running automatic installation display configuration and prompt for execution:
247    einfo "$0 - Please recheck configuration before execution:"
248    echo
249    echo "   Target:           $TARGET"
250       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
251       [ -n "$GRUB" ]   && echo "   Install grub to:  $GROOT / $GRUB"
252       [ -n "$MIRROR" ] && echo "   Using mirror:     $MIRROR"
253       [ -n "$ISO" ] && echo "   Using iso:        $ISO"
254       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
255       echo
256    einfon "Is this ok for you? [y/N] "
257    read a
258    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
259       eerror "Exiting as requested." ; eend 1
260       exit 1
261    fi
262 fi
263 # }}}
264
265 # create filesystem {{{
266 mkfs() {
267   if [ -n "$MKFS" ] ; then
268      einfo "Running $MKFS on $TARGET"
269      $MKFS $TARGET
270      eend $?
271   fi
272 }
273 # }}}
274
275 # modify filesystem settings {{{
276 tunefs() {
277   if [ -n "$TUNE2FS" ] ; then
278      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
279      $TUNE2FS $TARGET
280      eend $?
281   fi
282 }
283 # }}}
284
285 # mount the new partition or if it's a directory do nothing at all {{{
286 mount_target() {
287   if [ -n "$DIRECTORY" ] ; then
288      einfo "Running grml-debootstrap on a directory, nothing to mount."
289   else
290      if grep -q $TARGET /proc/mounts ; then
291         eerror "$TARGET already mounted, exiting."
292      else
293        [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
294        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
295        einfo "Mounting $TARGET to $MNTPOINT"
296        mount -o rw,suid,dev $TARGET $MNTPOINT
297        eend $?
298      fi
299   fi
300   if [ -n "$ISODIR" ] ; then
301      mkdir -p "$MNTPOINT/$ISODIR"
302      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
303   fi
304 }
305 # }}}
306
307 # install main chroot {{{
308 debootstrap_system() {
309   if ! grep -q $MNTPOINT /proc/mounts ; then
310           mount_target
311   fi
312   if grep -q $MNTPOINT /proc/mounts ; then
313      einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
314      [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
315      $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
316      eend $?
317   else
318      eerror "Error: $MNTPOINT not mounted, can not continue."
319      eend 1
320   fi
321 }
322 # }}}
323
324 # prepare chroot via chroot-script {{{
325 preparechroot() {
326   einfo "Preparing chroot system"
327   cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
328   chmod 755 $MNTPOINT/bin/chroot-script
329   mkdir $MNTPOINT/etc/debootstrap/
330
331   # make sure we have our files for later use via chroot-script
332   cp /etc/debootstrap/config          $MNTPOINT/etc/debootstrap/
333   cp /etc/debootstrap/packages        $MNTPOINT/etc/debootstrap/packages
334   cp /etc/debootstrap/variables       $MNTPOINT/etc/debootstrap/variables
335
336   cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
337
338   # make sure we can access network [relevant for cdebootstrap]
339   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
340
341   # setup default locales
342   [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
343
344   # copy any existing existing files to chroot
345   [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
346   [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
347   [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
348   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
349   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
350   eend 0
351 }
352 # }}}
353
354 # execute chroot-script {{{
355 chrootscript() {
356   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
357      mount_target
358   fi
359   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
360      einfo "Executing chroot-script now"
361      chroot "$MNTPOINT" /bin/chroot-script
362      eend $?
363   else
364      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
365      eend 1
366   fi
367 }
368 # }}}
369
370 # install booloader grub {{{
371 grub_install() {
372   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
373      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
374   else
375      einfo "Installing grub on ${GRUB}:"
376      [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
377      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
378      eend $?
379   fi
380 }
381 # }}}
382
383 # unmount $MNTPOINRT {{{
384 umount_chroot() {
385   if [ -n "$PARTITION" ] ; then
386      einfo "Unmount $MNTPOINT"
387      umount $MNTPOINT
388      eend $?
389   fi
390 }
391 # }}}
392
393 # execute filesystem check {{{
394 fscktool() {
395   if [ "$FSCK" = 'yes' ] ; then
396      [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
397      einfo "Checking filesystem on $TARGET using $FSCKTOOL"
398      $FSCKTOOL $TARGET
399      eend $?
400   fi
401 }
402 # }}}
403
404 # now execute all the functions {{{
405 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
406          chrootscript grub_install umount_chroot fscktool ; do
407     if stage $i ; then
408        $i && stage $i done || bailout 2 "i"
409     fi
410 done
411 # }}}
412
413 # stages {{{
414   echo done > $STAGES/grml-debootstrap
415 # }}}
416
417 if [ -n "$AUTOINSTALL" ] ; then
418    dialog --title "$0" --msgbox \
419           "Finished execution of ${0}.
420 Enjoy your Debian system." 6 60
421 else
422    einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
423 fi
424
425 ## END OF FILE #################################################################
426 # vim: ai tw=100 expandtab foldmethod=marker